﻿Public Class MyTextBoxHelper
    Inherits DependencyObject

    Public Shared Function GetEnterCommand(obj As TextBox) As ICommand
        Return DirectCast(obj.GetValue(EnterCommandProperty), ICommand)
    End Function
    Public Shared Sub SetEnterCommand(obj As TextBox, value As ICommand)
        obj.SetValue(EnterCommandProperty, value)
    End Sub
    Public Shared ReadOnly EnterCommandProperty As DependencyProperty = DependencyProperty.RegisterAttached("EnterCommand",
                                                                                                            GetType(ICommand),
                                                                                                            GetType(MyTextBoxHelper),
                                                                                                            New UIPropertyMetadata(Nothing, AddressOf EnterCommandProperty_Changed))
    Private Shared Sub EnterCommandProperty_Changed(ByVal d As DependencyObject, ByVal e As DependencyPropertyChangedEventArgs)
        Dim tb As TextBox = TryCast(d, TextBox)
        If tb Is Nothing Then Throw New NullReferenceException

        AddHandler tb.KeyDown, Sub(sender, e2)
                                   If e2.Key = Key.Enter Then
                                       DirectCast(d.GetValue(EnterCommandProperty), ICommand).Execute(Nothing)
                                   End If

                               End Sub
    End Sub


End Class
